package com.example.nto.domain.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.time.LocalDateTime;

@Data
@Entity
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "visits")
public class Visit {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "employee_id", referencedColumnName = "id", nullable = false)
    private Employee employee;

    @Column(name = "start_visit", columnDefinition = "TIMESTAMP", nullable = false)
    private LocalDateTime startVisit;

    @Column(name = "end_visit", columnDefinition = "TIMESTAMP")
    private LocalDateTime endVisit;

    @Column(name = "is_finished", nullable = false)
    private boolean isFinished = false;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "start_terminal_id", referencedColumnName = "id", nullable = false)
    private Terminal startTerminal;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "end_terminal_id", referencedColumnName = "id")
    private Terminal endTerminal;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "type_passage", referencedColumnName = "id", nullable = false)
    private Passage passage;
}

