package com.example.nto.dto.mappers;

import com.example.nto.domain.entity.Office;
import com.example.nto.dto.entity.OfficeDTO;
import com.example.nto.dto.mappers.employee.EmployeeItemMapper;
import lombok.experimental.UtilityClass;

import java.util.stream.Collectors;

@UtilityClass
public class OfficeMapper {
    public static OfficeDTO convertToDTO(Office office) {
        OfficeDTO officeDTO = new OfficeDTO();

        officeDTO.setId(office.getId());
        officeDTO.setName(office.getName());
        officeDTO.setDescription(office.getDescription());
        officeDTO.setAddress(office.getAddress());
        officeDTO.setLatitude(office.getLatitude());
        officeDTO.setLongitude(office.getLongitude());
        officeDTO.setLinkLogo(office.getLinkLogo());
        officeDTO.setTelephone(office.getTelephone());
        officeDTO.setEmail(office.getEmail());

        officeDTO.setEmployees(office.getEmployeeList().stream().map(EmployeeItemMapper::convertToDTO).collect(Collectors.toList()));
        officeDTO.setTerminals(office.getTerminals().stream().map(TerminalMapper::convertToDTO).collect(Collectors.toList()));

        return officeDTO;
    }

    public static Office convertFromDTO(OfficeDTO officeDTO) {
        Office office = new Office();

        office.setId(officeDTO.getId());
        office.setName(officeDTO.getName());
        office.setDescription(officeDTO.getDescription());
        office.setAddress(officeDTO.getAddress());
        office.setLatitude(officeDTO.getLatitude());
        office.setLongitude(officeDTO.getLongitude());
        office.setLinkLogo(officeDTO.getLinkLogo());
        office.setTelephone(officeDTO.getTelephone());
        office.setEmail(officeDTO.getEmail());

        // todo: Проверить, возможно, здесь нужно office.setEmployeeList() и office.setTerminals()

        return office;
    }
}
