package com.example.nto.dto.mappers;


import com.example.nto.domain.entity.Employee;
import com.example.nto.domain.entity.Passage;
import com.example.nto.domain.entity.Terminal;
import com.example.nto.domain.entity.Visit;
import com.example.nto.dto.entity.VisitDTO;
import com.example.nto.utils.Utils;
import lombok.experimental.UtilityClass;

import java.time.LocalDateTime;

@UtilityClass
public class VisitMapper {
    public static VisitDTO convertToDTO(Visit visit) {
        VisitDTO visitDTO = new VisitDTO();

        visitDTO.setId(visit.getId());
        visitDTO.setStartVisit(visit.getStartVisit().toString());

        if (visit.getEndVisit() == null) visitDTO.setEndVisit(null);
        else visitDTO.setEndVisit(visit.getEndVisit().toString());

        visitDTO.setFinished(visit.isFinished());

        if (visit.getEndVisit() == null) visitDTO.setDurationVisit(Utils.period(visit.getStartVisit(), LocalDateTime.now()));
        else visitDTO.setDurationVisit(Utils.period(visit.getStartVisit(), visit.getEndVisit()));

        visitDTO.setOfficeName(visit.getStartTerminal().getOffice().getName());
        visitDTO.setTypePassage(visit.getPassage().getPassageName());

        return visitDTO;
    }

    public static Visit convertFromDTO(Terminal terminal, Employee employee, Passage passage) {
        Visit visit = new Visit();

        visit.setEmployee(employee);
        visit.setStartVisit(LocalDateTime.now());
        visit.setFinished(false);
        visit.setStartTerminal(terminal);
        visit.setPassage(passage);

        return visit;
    }
}

