package com.example.nto.dto.mappers.employee;

import com.example.nto.domain.entity.Employee;
import com.example.nto.domain.entity.Visit;
import com.example.nto.dto.entity.employee.EmployeeItemDTO;
import com.example.nto.utils.Utils;
import lombok.experimental.UtilityClass;

import java.util.List;

@UtilityClass
public class EmployeeItemMapper {
    public static EmployeeItemDTO convertToDTO(Employee employee) {
        EmployeeItemDTO employeeItemDTO = new EmployeeItemDTO();
        employeeItemDTO.setId(employee.getId());
        employeeItemDTO.setName(employee.getName());
        employeeItemDTO.setSurname(employee.getSurname());
        employeeItemDTO.setPatronymic(employee.getPatronymic());
        employeeItemDTO.setProfileImageUrl(employee.getProfileImageUrl());
        employeeItemDTO.setOfficeName(employee.getOffice().getName());
        employeeItemDTO.setPosition(employee.getPosition().getName());
        employeeItemDTO.setBlocked(employee.isBlocked());

        // todo: Протестировать работу!

        List<Visit> visitsLast30Days = Utils.filterDateLast30Days(employee.getVisits());
        employeeItemDTO.setVisitStatus(employee.getVisits().stream().anyMatch(visit -> !visit.isFinished()));

        return employeeItemDTO;
    }
}
